package com.aliyun.iot.api.common.openApi;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.iot.util.LogUtil;
import com.aliyuncs.CommonRequest;
import com.aliyuncs.CommonResponse;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.exceptions.ClientException;

import java.util.HashMap;
import java.util.Map;

/**
 *   ƶ豸
 */
public class ThingManager extends AbstractManager {

    private static DefaultAcsClient client = getClient();

    /**
     *  豸
     *
     */
    public static JSONObject SetDeviceProperty(String IotId, String ProductKey, String DeviceName, Map<String,Object> Items) {
        CommonRequest request = executeTests("SetDeviceProperty");
        request.putQueryParameter("IotId", IotId);
        request.putQueryParameter("ProductKey", ProductKey);
        request.putQueryParameter("DeviceName", DeviceName);
        request.putQueryParameter("Items", JSONObject.toJSONString(Items));

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("豸Գɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("豸ʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }

    /**
     *  豸
     *
     */
    public static JSONObject SetDevicesProperty(String ProductKey , String  DeviceName1, String  DeviceName2, Map<String,Object>  Items) {
        CommonRequest request = executeTests("SetDevicesProperty");
        request.putQueryParameter("ProductKey", ProductKey);
        request.putBodyParameter("DeviceName.1", DeviceName1);
        request.putBodyParameter("DeviceName.2", DeviceName2);
        request.putQueryParameter("Items", JSONObject.toJSONString(Items));

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("豸Գɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("豸ʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }


    /**
     *  豸ķ
     *
     */
    public static JSONObject InvokeThingService(String IotId,String  ProductKey,String  DeviceName,String  Identifier,String Args) {

        CommonRequest request = executeTests("InvokeThingService");
        request.putQueryParameter("IotId", IotId);
        request.putQueryParameter("ProductKey", ProductKey);
        request.putQueryParameter("DeviceName", DeviceName);
        request.putQueryParameter("Identifier", Identifier);
        request.putQueryParameter("Args", Args);
        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("豸ķɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("豸ķʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }


    /**
     *  豸ķ
     *
     */
    public static JSONObject InvokeThingsService(String  ProductKey,String  name1,String name2,String  Identifier,String  Args) {
        CommonRequest request = executeTests("InvokeThingsService");
        request.putQueryParameter("ProductKey", ProductKey);
        request.putBodyParameter("DeviceName.1", name1);
        request.putBodyParameter("DeviceName.2", name2);
        request.putQueryParameter("Identifier", Identifier);
        request.putQueryParameter("Args", Args);
        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("豸ķɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("豸ķʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ķʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }


    public static void main(String[] args) {
        //1 豸
        Map<String,Object> propertymap =new HashMap<>();
        propertymap.put("WindSpeed_10",0);

        SetDeviceProperty("","a1BxptK****","safasda",propertymap);

        //2 豸


        Map<String,Object> propertymapNames =new HashMap<>();
        propertymapNames.put("hue",0);

        SetDevicesProperty("a1usVke****","C08ASLugvCzmqkfa****","gM8e7ew22be5dZCP****",propertymapNames);

        //3 豸ķ
        InvokeThingService("C08ASLugvCzmqkfaJ****000100",null,null,"ModifyVehicleInfo","{}");

        //4 豸ķ
        InvokeThingsService("a1usVkeS****","C08ASLugvCzmqkfa****","gM8e7ew22be5dZCP****","ModifyVehicleInfo","{}");

    }

}
