package com.aliyun.iot.api.common.openApi;

import com.alibaba.fastjson.JSON;
import com.aliyun.iot.util.LogUtil;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.exceptions.ClientException;
import com.aliyuncs.iot.model.v20180120.*;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ThingManagerForPopSDk  extends AbstractManager {

    private static DefaultAcsClient client = getClient();

    /**
     * 豸
     */
    public static void SetDeviceProperty(String IotId, String ProductKey, String DeviceName , String Items) {
        SetDevicePropertyResponse response =null;
        SetDevicePropertyRequest request=new SetDevicePropertyRequest();
        request.setDeviceName(DeviceName);
        request.setIotId(IotId);
        request.setItems(Items);
        request.setProductKey(ProductKey);

        try {
            response = client.getAcsResponse(request);

            if (response.getSuccess() != null && response.getSuccess()) {
                LogUtil.print("豸Գɹ");
                LogUtil.print(JSON.toJSONString(response));
            } else {
                LogUtil.print("豸ʧ");
                LogUtil.error(JSON.toJSONString(response));
            }

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response));
        }
    }

    /**
     * 豸
     *
     * @param ProductKey      Ե豸ĲƷKey
     * @param DeviceNames     ҪԵ豸б
     * @param Items  ҪõϢΪkey:valueݸʽΪ JSON String  
     *
     * @Des 
     */
    public static void SetDevicesProperty(String ProductKey, List<String> DeviceNames, String Items) {
        SetDevicesPropertyResponse response = new SetDevicesPropertyResponse();
        SetDevicesPropertyRequest request = new SetDevicesPropertyRequest();
        request.setDeviceNames(DeviceNames);
        request.setItems(Items);
        request.setProductKey(ProductKey);

        try {
            response = client.getAcsResponse(request);

            if (response.getSuccess() != null && response.getSuccess()) {
                LogUtil.print("豸Գɹ");
                LogUtil.print(JSON.toJSONString(response));
            } else {
                LogUtil.print("豸ʧ");
                LogUtil.error(JSON.toJSONString(response));
            }
        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response));
        }
    }


    /**
     * һ豸ִָķ񣨵豸
     *
     * @param IotId      Ҫѯ豸ID
     * @param ProductKey 豸ĲƷKey
     * @param DeviceName 豸
     * @param Identifier ߼豸ķIdentifier  
     * @param Args       Ҫ÷Ϣ    
     * @Des 
     */
    public static InvokeThingServiceResponse.Data InvokeThingService(String IotId, String ProductKey, String DeviceName,
                                                                     String Identifier, String Args) {
        InvokeThingServiceResponse response =null;
        InvokeThingServiceRequest request = new InvokeThingServiceRequest();
        request.setArgs(Args);
        request.setDeviceName(DeviceName);
        request.setIotId(IotId);
        request.setIdentifier(Identifier);
        request.setProductKey(ProductKey);

        try {
            response = client.getAcsResponse(request);

            if (response.getSuccess() != null && response.getSuccess()) {
                LogUtil.print("ִгɹ");
                LogUtil.print(JSON.toJSONString(response));
            } else {
                LogUtil.print("ִʧ");
                LogUtil.error(JSON.toJSONString(response));
            }
            return response.getData();

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("ִʧܣ" + JSON.toJSONString(response));
        }
        return null;
    }

    /**
     * 豸
     *
     * @param IotId      Ҫѯ豸ID  
     * @param ProductKey 豸ĲƷKey  
     * @param DeviceNames 豸б
     * @param Identifier  ߼豸ķIdentifier  
     * @param Args Ҫ÷Ϣ  
     *
     * @Des 
     */
    public static void InvokeThingsService(String IotId, String ProductKey, List<String> DeviceNames,
                                           String Identifier, String Args) {
        InvokeThingsServiceResponse response =null;
        InvokeThingsServiceRequest request = new InvokeThingsServiceRequest();
        request.setArgs(Args);
        request.setIdentifier(Identifier);
        request.setDeviceNames(DeviceNames);
        request.setProductKey(ProductKey);


        try {
            response = client.getAcsResponse(request);

            if (response.getSuccess() != null && response.getSuccess()) {
                LogUtil.print("豸ɹ");
                LogUtil.print(JSON.toJSONString(response));
            } else {
                LogUtil.print("豸ʧ");
                LogUtil.error(JSON.toJSONString(response));
            }

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸ʧܣ" + JSON.toJSONString(response));
        }
    }


    public static void main(String[] args) {

        /**豸*/
        String deviceName = "FaUcrp722sDCzr2tSeXe";
        String deviceProductkey = "a19wpcZ****";


        Map<String, Object> ext =  new HashMap<>();
        ext.put("hue", 0);

        //1 豸
        SetDeviceProperty(null, deviceProductkey, deviceName, JSON.toJSONString(ext));

        //2 豸
        List<String>  deviceNames = new ArrayList<>();
        deviceNames.add(deviceName);

        SetDevicesProperty(deviceProductkey, deviceNames, JSON.toJSONString(ext));

        //3 豸ķ
        InvokeThingService(null, deviceProductkey, deviceName, "ModifyVehicleInfo", "{}");

        //4 豸ķ
        List<String>  deviceNamesService = new ArrayList<>();
        deviceNamesService.add(deviceName);
        InvokeThingsService(null, deviceProductkey, deviceNamesService, "ModifyVehicleInfo", "{}");

    }
}
