package com.aliyun.iot.api.common.openApi;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.iot.util.LogUtil;
import com.aliyuncs.CommonRequest;
import com.aliyuncs.CommonResponse;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.exceptions.ClientException;


/**
 *  ƶ豸topoϵ
 */

public class TopoManager  extends AbstractManager  {


    private static DefaultAcsClient client = getClient();

    /**
     *  ֪ͨƶ豸˹ϵ
     */
    public static JSONObject NotifyAddThingTopo(String GwIotId, String GwProductKey, String GwDeviceName, JSONArray DeviceListStr) {
        CommonRequest request = executeTests("NotifyAddThingTopo");
        request.putQueryParameter("GwIotId", GwIotId);
        request.putQueryParameter("GwProductKey", GwProductKey);
        request.putQueryParameter("GwDeviceName", GwDeviceName);
        request.putQueryParameter("DeviceListStr", JSONObject.toJSONString(DeviceListStr));

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("豸˹ϵɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("豸˹ϵʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("豸˹ϵʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }

    /**
     *  ѯ豸豸е˹ϵ
     */
    public static JSONObject GetThingTopo(String IotId, String ProductKey, String DeviceName,Integer PageSize , Integer PageNo) {
        CommonRequest request = executeTests("GetThingTopo");
        request.putQueryParameter("IotId", IotId);
        request.putQueryParameter("ProductKey", ProductKey);
        request.putQueryParameter("DeviceName", DeviceName);
        request.putBodyParameter("PageSize", PageSize);
        request.putBodyParameter("PageNo", PageNo);

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("ѯ豸˹ϵɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("ѯ豸˹ϵʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("ѯ豸˹ϵʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }


    /**
     *  Ƴ豸豸е˹ϵ
     */
    public static JSONObject RemoveThingTopo(String IotId, String ProductKey, String DeviceName) {
        CommonRequest request = executeTests("RemoveThingTopo");
        request.putQueryParameter("IotId", IotId);
        request.putQueryParameter("ProductKey", ProductKey);
        request.putQueryParameter("DeviceName", DeviceName);

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("Ƴ豸˹ϵɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("Ƴ豸˹ϵʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("Ƴ豸˹ϵʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }



    /**
     *  Ƴ豸豸е˹ϵ
     */
    public static JSONObject RegisterDevice(String ProductKey, String DeviceName) {
        CommonRequest request = executeTests("RegisterDevice");
        request.putQueryParameter("ProductKey", ProductKey);
        request.putQueryParameter("DeviceName", DeviceName);

        CommonResponse response = null;

        try {
            response = client.getCommonResponse(request);
            JSONObject object = JSONObject.parseObject(response.getData());

            if (object.getBoolean("Success") != null && object.getBoolean("Success")) {
                LogUtil.print("ע豸ɹ");
                LogUtil.print(JSON.toJSONString(object));
            } else {
                LogUtil.print("ע豸ʧ");
                LogUtil.error(JSON.toJSONString(object));
            }
            return object.getJSONObject("Data");

        } catch (ClientException e) {
            e.printStackTrace();
            LogUtil.error("ע豸ʧܣ" + JSON.toJSONString(response.getData()));
        }
        return null;
    }


    public static void main(String[] args) {
        //豸̬עȡ豸deviceSecret豸֪豸֤Դ˲
        //Ԥע豸ʱʹ豸MACַSNкŵΪDeviceName
        JSONObject jsonObject = RegisterDevice("a12Z3Lf****","CtvfOzrTv9nBSOwc59HW4");

        //زѯǰ豸ǷԼtopoϵ
        JSONObject topoList = GetThingTopo("","a12Z3Lf****","CtvfOzrTv9nBSOwc59HW4",1,100);

        if(topoList.get("Data")!=null){
            LogUtil.error("豸Ѿtopoϵ");
            return;
        }

        //֪ͨƶ豸˹ϵ
        JSONArray topoArray = new JSONArray();
        JSONObject object = new JSONObject();
        object.put("ProductKey","a12Z3Lf****");
        object.put("DeviceName","CtvfOzrTv9nBSOwc59HW4");
        topoArray.add(object);

        NotifyAddThingTopo("","a1BxptK****","NYgA08M3DLS81sHRA6DQ",topoArray);

        // ѯ豸豸е˹ϵ
        GetThingTopo("","a1D8fJX****","0S10yKCel4LGht7K91VV",1,10);

        // Ƴ豸豸е˹ϵ
        //RemoveThingTopo("","","");

    }
}
